# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/gpio/st,nomadik-gpio.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Nomadik GPIO controller

description:
  The Nomadik GPIO driver handles Nomadik SoC GPIO blocks. This block has also
  been called ST STA2X11. On the Nomadik platform, this driver is intertwined
  with pinctrl-nomadik.

maintainers:
  - Linus Walleij <linusw@kernel.org>

properties:
  $nodename:
    pattern: "^gpio@[0-9a-f]+$"

  compatible:
    enum:
      - st,nomadik-gpio
      - mobileye,eyeq5-gpio

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  "#gpio-cells":
    const: 2

  gpio-controller: true

  interrupt-controller: true

  "#interrupt-cells":
    const: 2

  gpio-bank:
    description: System-wide GPIO bank index.
    $ref: /schemas/types.yaml#/definitions/uint32

  st,supports-sleepmode:
    description: Whether the controller can sleep or not.
    $ref: /schemas/types.yaml#/definitions/flag

  clocks:
    maxItems: 1

  gpio-ranges:
    maxItems: 1

  ngpios:
    minimum: 0
    maximum: 32

  resets:
    maxItems: 1

required:
  - compatible
  - reg
  - interrupts
  - "#gpio-cells"
  - gpio-controller
  - interrupt-controller
  - gpio-bank

unevaluatedProperties: false

allOf:
  - if:
      properties:
        compatible:
          contains:
            const: mobileye,eyeq5-gpio
    then:
      properties:
        st,supports-sleepmode: false

examples:
  - |
    gpio@8012e080 {
        compatible = "st,nomadik-gpio";
        reg =  <0x8012e080 0x80>;
        interrupts = <0 120 0x4>;
        #gpio-cells = <2>;
        gpio-controller;
        #interrupt-cells = <2>;
        interrupt-controller;
        st,supports-sleepmode;
        gpio-bank = <1>;
    };
